#include <iostream>
#include <stdlib.h>
#include <string>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include "Segment.h"
#include "SegmentAna.h"
#include "Analyzer.h"
#include "IfAna.h"

Analyzer::Analyzer() {
  ipRef = "";
  ipRefPath = "";
  option = "";
}

void Analyzer::setIpRef(string ipApp) {
  ipRef = ipApp;
}

void Analyzer::setIpRefPath(string pathApp) {
  ipRefPath = pathApp;
}

void Analyzer::setOption(string opApp) {
  option = opApp;
}

//checks if a tunnel is a vantage point.. and stores it into vp, in future to implement a list instead of vp
int Analyzer::setVanPoint(Segment s) {
  if (s.getIsTunnel()==true) {
    vp=s;
    return 1;
  }
  else return 0;
}

//for now just resolves into ipv4 addresses
string Analyzer::resolve(string hostn) {
  IfAna ia;
  return ia.resolve(hostn);
}

Segment Analyzer::analyse(string a,string b) {
  SegmentAna sa;
  sa.setIpRefPath(ipRefPath);
  sa.setIpRef(ipRef);
  sa.setOption(option);
  Segment s;
  int addA; //if a is an ipv4 address (1) or not (0), in future also ipv6
  int addB;
  in_addr in;
  in_addr *p_in=&in;
  const char* s_addr=a.c_str();
  in_addr in2;
  in_addr *p_in2=&in2;
  const char* s_addr2=b.c_str();
  int res=inet_pton(AF_INET, s_addr, p_in);
  int res2=inet_pton(AF_INET, s_addr2, p_in2);
  if(res==1){
     addA = 1;
     if(res2==1){
        addB = 1;
     }
     else addB=0;
  }
  else {
    addA=0;
    if(res2==1){
       addB = 1;
    }
    else addB=0;
  }
  switch(addA){
    case(1):
      if (addB==1) s=sa.create("","",a,b);
      else {
        if (resolve(b)!="") s=sa.create("",b,a,resolve(b));
        else {
          if (option == "-v") {
            printf("UNKNOWN2 ");
            printf("%s -> %s\n",a.c_str(),b.c_str());
          }
          else cerr <<"error resolving interfaces"<<endl;
          exit(2);
        }
      }
      break;
    case(0):
      if (addB==1) {
        if (resolve(a)!="") s=sa.create(a,"",resolve(a),b);
        else {
          if (option == "-v") {
            printf("UNKNOWN1 ");
            printf("%s -> %s\n",a.c_str(),b.c_str());	    
	  }	
          else cerr <<"error resolving interfaces"<<endl;
          exit(2);
        }
      }
      else if ((resolve(b)!="")&&(resolve(a)!="")) s=sa.create(a,b,resolve(a),resolve(b));
           else {
             if (option == "-v") {
	       if ((resolve(a)=="")&&(resolve(b)=="")) printf("UNKNOWN12 ");
	       else if (resolve(a)=="") printf("UNKNOWN1 ");
	            else printf("UNKNOWN2 ");
               printf("%s -> %s\n",a.c_str(),b.c_str());
             }
             else cerr <<"error resolving interfaces"<<endl;
             exit(2);
           }
      break;
  }

 // cout <<s.getHostnamein()<<endl;
  s=sa.analyse(s);
  setVanPoint(s);
  return s;
}

//returns the vantage point.. in the future the list of vp of a path
Segment Analyzer::getVanPoint() {
  return vp;
}
